
             
;    Filename:	  628strb5.asm   Lampe stroboscopique  dephasage  PIC 16F628
;					rgime maxi >= 10000t/mn, prcision amliore

;                               avec compte-tours sensible (reglage carburation)               
;    Date:22/10/11             Utilise l'arithmtique flottante pour tous 
;                                les calculs 
;    philippe.loutrel@laposte.net 


;Mme  electronique que la V3/V4     

;De 1  50 d'avance,  2 ou 4 temps. S'il n'existe pas d'interrupteur "2T/4T"
; le niveau de la patte 3 reste  +5V, soit la position 4 Temps.

;Un capteur  induction   est activ par l'etincelle du cylindre No 1

;                        LAMPE STROBOSCOPIQUE

;L'utilisateur dispose de deux interrupteurs  poussoir pour INCrementer les degrs
;(deplacement du spot ds le sens de la rotationdu moteur) ou les DECrementer
;En option un interrupteur permet de choisir le cycle du moteur: 2 ou 4 temps (4 par dfaut)
;L'afficheur LCD affiche: N t/mn  (10t/mn de definition, le dernier chiffre tant toujours 0 pour la lisibilit)
;			  Deg nb de degrs d'avance (1 de definition) initialis  10 
;Exemple : De 4230  4239  t/mn, 25 d'avance, on l'affichage suivant

;		******************************************
;		*                                        *
;		*  t/mn 4230                              *
;		*                                        *
;		*                                        *
;		*  Deg 25                                *
;		*                                        *
;		*                                        *
;		******************************************            
;	    		*    			*
;		       ***		       ***
;	    		B1              B2


; Utilise  les biblis pour flottants 32 bits et LCD (incluses) 
;            
;Tout en units de 8s 
;Quelques chiffres; Pour un 4 temps, la priode est de 720 entre deux tincelles d'un cylindre.
;1000t/mn  T =120ms 1= 167s avance typique 10 = 1700s
;3000         40        55.6                 28    1560
;6000         20        27.8                 30     833
;Donc, il faut attendre entre 0.7 et 2ms aprs une tincelle pour dclencher le flash qui
;illuminera le repre mobile align avec le repre fixe du PMH.
;Aprs une tincelle on commence par attendre puis flasher en utilisant le dlai calcul
; la priode precedante. Aprs le flash il reste au moins 19ms pour tous les calculs et affichages.

;Tout ceci est gratuit, libre de tout droit.


;**********************************************************************
	ERRORLEVEL	-302			;vite des messages inutiles

	list      p=16F628           ; list directive to define processor
	#include <p16F628.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_OFF& _PWRTE_ON  &_LVP_OFF & _INTRC_OSC_NOCLKOUT

;Bibli flottants
		INCLUDE <DEV_FAM.INC>	; PIC16 device specific definitions

		INCLUDE <MATH16.INC>    ; PIC16 math library definitions


;VARIABLES
;DE h'20'  h'34', invisibles mais prsentes, les accumulateurs et variables 
;pour le flottant. Par exemple AEXP, AARGB0 etc

	cblock	h'35'	 
	w_temp        		  ; variable used for context saving 
	status_temp   		  ; variable used for context saving

	hex_H				; de 0  65535, dcod en ASCII par la SUB HEX_to_ASCII 
	hex_L	;
	zc_H				;constante
	zc_L 
	DIXMIL				;valeurs ASCII correspondantes  hex
	MIL
	CENT
	DIX
	UNIT
	Dflags				;flag pour add 16 bits
	CS					;Carry Storage pour calcul de T, at aussi les sub WAIT
	inscar				;car ASCII  afficher

	Front				;Flag = 1 qd tincelle, ie front descendant
	TZ_H				;High byte de TMR0 unit 8s*256 = 2.048s
	T_H					;T =Periode entre deux tincelles 
	T_L					;unit de T = 8s 
	T_HS				;T recopi en TS pour les calculs, laisse T pour l'ISR
	T_LS


	N_H					;t/mn 
	N_L

	degdem				;Nb de degrs de retard pour flash,demand par l'utilisateur
	cpt					;compteur banalis
	cpt_bp				;compteur entre 2 lectures des boutons INC et DEC
						;initialis  la valeur  de wait_bp (ci dessous)



	D_H     		    ; Delai pour flash
	D_L	        

	TOG					;Cas du 2 temps. Alterne pair et impair
	cpt_ludo			;Variable pour le compteur de boucle d'affichage de la version
	exp270				;stock 270 en flottant
	B0270
	B1270
	B2270
	

	endc
	
	
	#DEFINE	MOT4	PORTA,4	; Si pas d'inter 2 temps, RA4 reste au niveau 1
	
;Valeurs numeriques

TC		equ	d'13'		;temps coul entre front d'ticelle et dbut d'attente pour le flash
						;soit environ 40s soit 13 units de 3s 
wait_bp	equ	d'3'		;nb de passages entre deux polling des bp(20, lent)
Dflash	equ	d'12'		;dure du flash Dflash*4 en s. 

	
;**********************************************************************
START	ORG     0               	; MEM FLASH (2K)
	goto	Main			


ISR	ORG	h'04'			;Interrupt Service Routine( Front et Tmr0)

	movwf	w_temp		;Save context. First w
	swapf	STATUS,w	;twist STATUS 
	movwf	STATUS_TEMP	; and save it
	btfss	INTCON,T0IF	; BR  Le bit d'IT de Tmr0 est  1?
	goto	Ouv			;non, c'est donc un front d'tincelle
	incf	TZ_H,f		;oui, toutes les 256*8s = 2.048ms
Finit
	bcf		INTCON,INTF	;pour eviter retour immdiat RAZ du flag d'IT
	bcf		INTCON,T0IF	;clear l'IT sinon retour immdiat
	swapf	STATUS_TEMP,w		;Restore context Untwist STATUS
	movwf	STATUS
	swapf	w_temp,f	;Twist twice since w was stored untwitesd!
	swapf	w_temp,w
	RETFIE				;Retour
Ouv	
	btfss	MOT4
	goto	ouv2t		;0 donc 2 temps	
ist
	movfw	TMR0		;on sauve la priode en units de 8s
	clrf	TMR0		;Relancer TMR0
	movwf	T_L			;TZ_H  garnie en u de 2ms
	movfw	TZ_H
	movwf	T_H
	clrf	TZ_H		;RAZ pour prochaine periode
	bsf		Front,0		;signaler  la boucle d'attente du Main que T est prete
	goto	Finit
ouv2t					;2 temps, cumuler deux priodes pour calculer N
	incf	TOG,f		;on alterne 
	btfsc	TOG,0
	goto	IST			;la 2me priode est cumule ds T
	goto	Finit		;la premire priode est ds T, aller accumuler la deuxime
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Main
	org	h'25'			;Laisse la place en h4 pour Interrupt Service Routine
	movlw	7
	movwf	cmcon		;desactive le comparateur.Indispensable!

  	call	Initv		;Initialiser les variables et constantes

;    ***** Affichage de la version *******

	movlw	h'82'		;Positionnement sur la 1ere ligne
	call 	envins		;
	movlw	'S'
	call 	envcar
	movlw	't'
	call 	envcar
	movlw	'r'
	call 	envcar
	movlw	'o'
	call 	envcar
	movlw	'b'
	call 	envcar
	movlw	'o'
	call 	envcar
	movlw	'P'
	call 	envcar
	movlw	'i'
	call 	envcar
	movlw	'c'
	call 	envcar

	movlw	h'C4'		; Pareil 2eme ligne
	call 	envins
	movlw	' '
	call	envcar
	movlw	' '
	call	envcar
	movlw	'v'
	call 	envcar
	movlw	'5'			;N de version
	call 	envcar	

	
	call 	WAIT_2s		;Attendre 2s

	call 	cls			;Effacement de l'ecran et commencer le programme

Wait					; Boucle d'attente 
	btfss	Front,0		;Si Front=1, c'est qu'une IT (tincelle) est arrive
	goto	wait		;Front = 0, attendre

	
	movfw	T_H			; front juste arrive, recopier T ds TS
	movwf	T_HS
	movfw	T_L
	movwf	T_LS													
	call	Wait_D		;D dj calcul avec la T precedente
	call	Flash
	call	Affic_N4ch
	call	Affic_Deg
	call	Calc_N		
	call	Calc_D
	call	chkswm		;polling des bp	
	
	clrf	Front		;pour attendre un front et ne pas utiliser le front precedent	

	goto	Wait		;attendre prochain front
	

;END   MAIN::::::::::::::::::::::::::::::::::::::  Les SUBS::::::::::::::::::::::::::::::::::::::::


AFFIC_deg				;SUB d'affichage des degrs sur 2 chiffres
	movlw	h'C0'		;instruction debut de ligne 2 sur LCD
	call	envins
	movlw	'D'			;ASCII pour lettre "D"
	call	envcar
	movlw	'e'			;e
	call	envcar
	movlw	'g'			;g
	call	envcar
	movlw	' '			;espace  
	call	envcar
	clrf	Hex_H		;affiche sur 2 chiffres
	movfw	degdem
	movwf	Hex_L
	call	Hex_to_Ascii
	movfw	dix
	call	Envcar
	movfw	unit
	call	Envcar
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Affic_N4ch				;SUB affiche N sur 4 chiffres
	call	cls
	movlw	't'
	call	envcar
	movlw	'/'
	call	envcar
	movlw	'm'
	call	envcar
	movlw	'n'
	call	envcar
	movlw	' '			;afficher t/mn_ 
	call	envcar
	movfw	N_H
	movwf	Hex_H
	movfw	N_L
	movwf	Hex_L 
	call	hex_to_ascii;decompose N en 4 codes ascii
	movfw	mil			;afficher les 4 chiffres
	call	envcar
	movfw	cent
	call	envcar
	movfw	dix
	call	envcar
	movlw	'0'			;affiche 0 en dernier chiffre pour stabilit
	call	envcar
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CALC_D					;SUB de calcul de delai pour le flash
	clrf	AARGB0		;D=degdem*T/270
	clrf	AARGB1
	movfw	degdem
	movwf	AARGB2		;degdem ds Acc A pour float
	call	Flo32
	movfw	AEXP		;save fl degdem ds Acc B
	movwf	BEXP
	movfw	AARGB0
	movwf	BARGB0
	movfw	AARGB1
	movwf	BARGB1
	movfw	AARGB2
	movwf	BARGB2
	clrf	AARGB0		;T ds Acc A pour float
	movfw	T_HS
	movwf	AARGB1
	movfw	T_LS
	movwf	AARGB2
	call	Flo32		;fl T ds Acc A * Acc B(degdem) resultat ds Acc A
	call	Fpm32
	movfw	exp270		;fl 270 ds Acc B
	movwf	Bexp
	movfw	B0270
	movwf	BARGB0
	movfw	B1270
	movwf	BARGB1
	movfw	B2270
	movwf	BARGB2
	call	Fpd32		;divise Acc A/Acc B resultat  D ds Acc A
	call	Int32		;D entier sur 24 bits ds Acc A
	movfw	AARGB1
	movwf	D_H
	movfw	AARGB2
	movwf	D_L
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CALC_N					;SUB calcul de N par N=15 000 000/Tu de 8s
	clrf	AARGB0		;T sur 16 bits
	movfw	T_HS
	movwf	AARGB1
	movfw	T_LS
	movwf	AARGB2
	call	FLO32		; T ds Acc A .Conversion d'un entier 24 bits (sign)
						;en flottant 32 bits ds Acc A
	movfw	AEXP		;move fl T ds Acc B
	movwf	BEXP
	movfw	AARGB0
	movwf	BARGB0
	movfw	AARGB1
	movwf	BARGB1
	movfw	AARGB2
	movwf	BARGB2

	movlw	h'72'		;7 500 000= h'72 70 E0' au lieu de 15 000 000
	movwf	AARGB0		;car 24 bits avec signe-->8M maxi
	movlw	h'70'
	movwf	AARGB1
	movlw	h'E0'
	movfw	AARGB2		
	call	FLO32		; fl 7 500 000 ds Acc A
	incf	AEXP,f		; 15 000 000 ds Acc A
	call	FPD32		;A/B  N= 15 000 000/T ds A, en flottant
	call	INT32		;Convertit N en entier sur 24 bits ds Acc A0,1,2
	movfw	AARGB2		;N tient sur 16 bits,donc AARGB0=0
	movwf	N_L			;prpare N
	movfw	AARGB1
	movwf	N_H
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHKSWM					;SUB de lecture des bp et inter,met  jour degdem
	decfsz	cpt_bp,f	;est on pass assez de fois ici?
	return				;non, (doit-on attendre qd meme (anti rebond)?)
	movlw	wait_bp		;oui, re initialiser ce compteur
	movwf	cpt_bp
	btfss	PORTB,1		;bp INC = 1 si pas appuy(off)
	goto	k1			;on
	btfsc	PORTB,2		;off et DEC?
	return				;off,rien  faire
	call	wait_100ms	;on
	btfss	PORTB,1		;INC?
	goto	k2			;on donc B1&B2
	movlw	1			;off,donc decroitre mais s'arreter  1
	subwf	degdem,w
	btfss	status,z	;degdem=1, ne rien faire	
	decf	degdem,f	;OK, on peut decrementer
k2	
	return	
k1	
	call	wait_100ms	;DEC ?
	btfss	PORTB,2
	goto	k2			;on,B1&B2
	movfw	degdem		;off mais INC on, donc
	sublw	d'50'		;verifier A<=50
	btfsc	STATUS,C	;C=0, A>50, ne rien faire
	incf	degdem,f	;C=1, A<=50, croitre
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
FLASH					;SUB d'allumage LED pour 1 ms
	bsf		PORTB,5		;niveau haut pour allumer
	movlw	Dflash
	call	wait_4w		;attendre 4w s
	bcf		PORTB,5
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
initio					;SUB d'Initialisation des I/O                 
	bsf		STATUS,RP0	;Aller dans Bank 1(set bit 5 de Status(adr 03))
	movlw	b'00000111'	;Make RB0 INPUT (hardware pin6) 1 for 1nput,etincelle
				;     RB1 INPUT (pin 7) bp droite INC 0 qd appuy
				;     RB2 INPUT (pin 8) bp gauche DEC 0 qd appuy
				;     RB3 OUTPUT (pin 9)Enable du LCD 0 pour 0utput
				;     RB4 OUTPUT (pin 10)R/S du LCD 0 pour une instruction
				;				    1 pour un affichage
				;     RB5 OUTPUT (pin 5)LED on  qd 1
	movwf	TRISB

	movlw	b'00010000'	;Make RA0  RA3 OUTPUT(pins 17,18,1,2)pour 4 fils de data LCD
						;Make RA4 (pin 3) INPUT pour inter 2 ou 4 temps (1 pour 4 temps)
	movwf	TRISA
	bcf		STATUS,RP0	;Revenir  Bank 0 Reset bit de Status
	clrf	PORTB
	call	wait_1ms	;0.1s d'attente pour LCD
	return
;;;;;;;;;;;;;;;;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Initv					;SUB d'initialisation des variables
	clrf	INTCON		;Aucune IT autorise
	call	Initio		; Les E/S
	clrf	tog
	clrf	T_HS
	clrf	T_LS
	clrf	Front
	clrf	AARGB0		;preparer 270 en flottant 1=T8s/270, u de 3s
	movlw	1
	movwf	AARGB1		;270= 256 + 14
	movlw	d'14'
	movwf	AARGB2
	call	Flo32		; 270 en flottant  ds acc A

	movfw	AEXP		;sauver cette valeur
	movwf	Exp270
	movfw	AARGB0
	movwf	B0270
	movfw	AARGB1
	movwf	B1270
	movfw	AARGB2
	movwf	B2270

	clrf	D_H			;premier dlai pour flash
	movlw	d'254'
	movwf	D_L

	movlw	d'10'		;10 d'autorit
	movwf	degdem
	movlw	wait_bp
	movwf	cpt_bp		;periode de polling des bp

	call	init_lcd
	bcf		INTCON,T0IF	;bit d'IT de Tmr0
	bcf		INTCON,INTF	;bit d'IT ligne RB0(etincelle)
	bsf		INTCON,T0IE	;Enable Tmr0
	bsf		INTCON,INTE	;Enable RB0

	movlw	b'10010010'	;No pull-up,Edge - de RB0,Internal clock for Tmr0,
	bsf		STATUS,RP0	;Prescaler is for Tmr0 (PSA=0), divide by 2**(1+2)=8
	movwf	OPTION_REG
	bcf		STATUS,RP0
	bsf		INTCON,GIE	;Enable all ITs
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_4w					;SUB d'attente 4w s
	addlw	-1
	btfss	status,z
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;2s;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_10ms				;SUB attente 10ms
	movlw	d'10'
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT_100ms				;SUB attente 100ms
	movlw	d'100'
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT_2s					;SUB d'attente de 2s
	movlw	d'20'
	movwf	cpt_ludo	;Mettre 20 dans la variable de boucle du compteur
	call 	WAIT_100ms
	decfsz	cpt_ludo,f
	goto 	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_D					;SUB d'attente avant flash pour les degrs demands
	
	incf	D_H,f		;au cas o 0
	movlw	TC			;correction pour temps de calcul entre l'arrive du
						;front et le premier passage en a, ci-dessous.
	subwf	D_L,f		;L_byte - TC
	btfss	status,c
	decf	D_H,f		;borrow
	movf	D_L,f		;si L=0, le mettre  1,sinon 255 boucles en trop!
	btfsc	D_L,f
	incf	D_L,f		;entre le front d'tincelle et ici: 44s=14u=TC
a	
	decfsz	D_L,f		;decompte les u de 3s
	goto	a
	decfsz	D_H,f		;unites de 256x3 s
	goto	a
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


	#include <BibLcd2.inc>	     ;Bibliothque LCD

	#include <FP32.A16>	     ;Package Flottant
				     			;Add, Sub,Mpy, Div
       
      
	END                    	; directive 'end of program':::::::::::::::::::::::::::::::::::::::::::::



